/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2009 Akira Ujio
 * 
 *  上記著作権者は，以下の (1)〜(4) の条件か，Free Software Foundation 
 *  によって公表されている GNU General Public License の Version 2 に記
 *  述されている条件を満たす場合に限り，本ソフトウェア（本ソフトウェア
 *  を改変したものを含む．以下同じ）を使用・複製・改変・再配布（以下，
 *  利用と呼ぶ）することを無償で許諾する．
 *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
 *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
 *      スコード中に含まれていること．
 *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
 *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
 *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
 *      の無保証規定を掲載すること．
 *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
 *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
 *      と．
 *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
 *        作権表示，この利用条件および下記の無保証規定を掲載すること．
 *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
 *        報告すること．
 *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
 *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
 * 
 *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
 *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，その適用可能性も
 *  含めて，いかなる保証も行わない．また，本ソフトウェアの利用により直
 *  接的または間接的に生じたいかなる損害に関しても，その責任を負わない．
 * 
 *  @(#) $Id: cpu_config.h,v 1.9 2003/12/24 07:24:40 honda Exp $
 */

/*
 *	プロセッサ依存モジュール（iPhone用）
 */

#ifndef _CPU_CONFIG_H_
#define _CPU_CONFIG_H_

/*
 *	API定義
 */
#include "api.h"

/*
 *  カーネルの内部識別名のリネーム
 */
#include <cpu_rename.h>

#ifndef _MACRO_ONLY

/*
 *  iPhone用標準インクルードファイル
 */

#include <signal.h>
#include <setjmp.h>


/*
 *  TCB 関連の定義
 *
 *  cpu_context.h に入れる方がエレガントだが，参照の依存性の関係で，
 *  cpu_context.h には入れられない．
 */

/*
 *  TCB 中のフィールドのビット幅の定義
 */
#define	TBIT_TCB_PRIORITY	8	/* priority フィールドのビット幅 */
#define	TBIT_TCB_TSTAT		8	/* tstat フィールドのビット幅 */

/*
 *  タスクコンテキストブロックの定義
 */
typedef struct task_context_block {
	SIZE	stksize;				/*取得したスタックサイズ*/
	jmp_buf start_env;	/* CPUスタート時のコンテキスト*/
	jmp_buf env;				/* CPUコンテキスト */
} CTXB;

/*
 *	割り込みハンドラ
 */
#define INHNO_SIGUSR1	SIGUSR1
#define INHNO_SIGUSR2	SIGUSR2

/*
 *   CPU例外ハンドラ
 */

#define EXCHNO_ZDIV  SIGFPE

/*
 *  システム状態参照
 */

extern BOOL interrupt_flg;

Inline BOOL
sense_context()
{
	return interrupt_flg;
}

extern IMS locked_ims;

Inline BOOL
sense_lock()
{
	IMS currentSet;
	
	sigprocmask(SIG_SETMASK,0,&currentSet);
	
	return currentSet == locked_ims;  
}


#define t_sense_lock	sense_lock
#define i_sense_lock	sense_lock

/*
 *  CPUロックとその解除（タスクコンテキスト用）
 *
 */

Inline void
t_lock_cpu()
{
    sigset_t  newmask; 
    sigfillset(&newmask);
    sigprocmask(SIG_SETMASK,&newmask,0);
}

Inline void
t_unlock_cpu()
{
    sigset_t  mask;    
    sigemptyset(&mask);
    sigprocmask(SIG_SETMASK,&mask,0);
}

/*
 *  CPUロックとその解除（非タスクコンテキスト用）
 */

#define i_lock_cpu		t_lock_cpu
#define i_unlock_cpu	t_unlock_cpu

/*
 *  タスクディスパッチャ
 */

/*
 *  最高優先順位タスクへのディスパッチ
 *
 *  dispatch は，タスクコンテキストから呼び出されたサービスコール処理
 *  内で，CPUロック状態で呼び出さなければならない．
 */
extern void	dispatch();


/*
 *  現在のコンテキストを捨ててディスパッチ
 *
 *  exit_and_dispatch は，CPUロック状態で呼び出さなければならない．
 */

extern void    exit_and_dispatch(void);

/*
 *  割込みハンドラ／CPU例外ハンドラの設定
 */


/*
 *  割込みハンドラの設定
 *
 *  ベクトル番号 inhno の割込みハンドラの起動番地を inthdr に設定する．
 */

Inline void
define_inh(INHNO inhno, FP inthdr)
{
		struct sigaction action;

		action.sa_handler = inthdr;
		action.sa_flags   = SA_RESTART;
		sigemptyset(&action.sa_mask);
    
		sigaction(inhno, &action, 0);    
}

/*
 *  CPU例外ハンドラの設定
 *
 *  ベクトル番号 excno のCPU例外ハンドラの起動番地を exchdr に設定する．
 */
Inline void
define_exc(EXCNO excno, FP exchdr)
{
    struct sigaction action;

    action.sa_handler = exchdr;
    sigemptyset(&action.sa_mask);

    sigaction(excno, &action, 0);
}

/*
 *  割込みハンドラ／CPU例外ハンドラの出入口処理
 */

/*
 *  割込みハンドラの出入口処理の生成マクロ
 *
 */

extern void prologue_isr(void);
extern void epilogue_isr(void);
#define		INTHDR_ENTRY(inthdr)	void inthdr##_entry(void){ prologue_isr(); inthdr(); epilogue_isr(); }



/*
 *  CPU例外ハンドラの出入口処理の生成マクロ
 *
 */
#define INT_ENTRY(inthdr)   inthdr##_entry

#define		EXCHDR_ENTRY(exchdr)	void exchdr##_entry(VP sp){ prologue_isr(); exchdr(sp); epilogue_isr(); }

#define EXC_ENTRY(exchdr) exchdr##_entry

/*
 *  CPU例外の発生した時のシステム状態の参照
 */

/*
 *  CPU例外の発生した時のディスパッチ
 */
Inline BOOL
exc_sense_context(VP p_excinf)
{
	return((*((UH *) p_excinf) & 0x1000) == 0);
}

/*
 *  CPU例外の発生した時のCPUロック状態の参照
 */
Inline BOOL
exc_sense_lock(VP p_excinf)
{
	return((*((UH *) p_excinf) & 0x0700) == 0x0700);
}


/*
 *  プロセッサ依存の初期化
 */
extern void	cpu_initialize(void);

/*
 *  プロセッサ依存の終了時処理
 */
extern void	cpu_terminate(void);

/*
 *	割り込みの発生
 */
extern void itron_interrupt(int intno);

#endif /* _MACRO_ONLY */
#endif /* _CPU_CONFIG_H_ */







